/*
  ab * cd ̌ʁAabcd 0xXXXXXXXXłf[^10TB

   bd mul22 ---> A
  ad0 mul12 ---> B
  cb0 mul21 ---> C
 ac00 mul11 ---> D
      addAB ---> E
      addCD ---> F
      addEF --->
      check

  RpC@Fgcc -lpthread -DTHREAD=8 -DJOB_SIZE=256 -o Program_2_M Source_Program_2_M.c
          THREADFXbh̎w
        JOB_SIZEF1Wũf[^w
  
*/
#include <stdio.h>
#include <pthread.h>
#define PATTERN  (0x0ABCDEF00)	// 6  
#define COUNT    (10)
static struct {int a,b;} found[COUNT];
static volatile unsigned int    count=COUNT;
static unsigned int    job_data[(0x10000/JOB_SIZE)+1];
static unsigned int    job_index;
static unsigned int    job_counts;
static unsigned int    job_size=JOB_SIZE;
static pthread_mutex_t mutex_count;
static pthread_mutex_t mutex_job;

#define mul11() ( A = (a * c) << 16 )
#define mul12() ( B = (a * d) << 8 )
#define mul21() ( C = (c * b) << 8 )
#define mul22() ( D = (b * d) )
#define addAB() ( E = (A + B) )
#define addCD() ( F = (C + D) )
#define addEF() ( X = (E + F) )
#define check() ( !(X ^ PATTERN) )

unsigned int *get_job()
{
  int index;

  if ( pthread_mutex_lock(&mutex_job) )
      printf(" Mutex Lock Error (%d)\n",__LINE__);
  if (job_index + 1 == job_counts)
  {
    if ( pthread_mutex_unlock(&mutex_job) )
      printf(" Mutex Unlock Error (%d)\n",__LINE__);
    return NULL;
  }
  index = job_index++;
  if ( pthread_mutex_unlock(&mutex_job) )
      printf(" Mutex Unlock Error (%d)\n",__LINE__);
  return &job_data[index];
}

void sub(unsigned int i,unsigned int job_count)
{
  int a,b,c,d,A,B,C,D,E,F,X;
  unsigned int j;

  do
  {
    for ( j = 0 ; count && j <= 0xFFFF ; j++ )
    {
      a = i >> 8;	// 1oCgo(ӏ)
      b = i & 0xFF;	// 1oCgo(Ӊ)
      c = j >> 8;	// 1oCgo(Eӏ)
      d = j & 0xFF;	// 1oCgo(EӉ)
      mul22();	// ZP(ʁ~)
      mul12();	// ZQ(ʁ~) << 8
      mul21();	// ZR(ʁ~) << 8
      mul11();	// ZS(ʁ~) << 16
      addCD();	// ZP(ZP{ZR)
      addAB();	// ZQ(ZQ{ZS)
      addEF();	// ZR(ZP{ZQ)
      if( check() )
      {
	if ( pthread_mutex_lock(&mutex_count) )
            printf(" Mutex Lock Error (%d)\n",__LINE__);
	count--;
	found[count].a = i;
	found[count].b = j;
	if ( pthread_mutex_unlock(&mutex_count) )
            printf(" Mutex Unlock Error (%d)\n",__LINE__);
	printf("%8.8X = %4.4X * %4.4X\n",X,i,j);
      }
    }
    i++;
  } while ( --job_count );
  return;
}

void thread_job(void *arg)
{
  unsigned int *jobp;

  while ( (jobp = get_job()) != NULL )
    sub(*jobp,*((unsigned int *)arg));
}

void main(void)
{
  unsigned int i,j;
  pthread_t    jobs[THREAD]; 

  for ( i = j = 0 ; j <= 0xFFFF ; j+=JOB_SIZE )
    job_data[i++] = j;
  job_counts = i;
  job_index = 0;
  pthread_mutex_init(&mutex_job, NULL);
  pthread_mutex_init(&mutex_count, NULL);

  for ( i = 0 ; i < THREAD ; i++ )
  {
    if ( pthread_create(&jobs[i], NULL, (void *)thread_job, (void *)&job_size) )
        printf(" Thread Create Error (%d)\n",__LINE__);
  }
  
  for ( i = 0; i < THREAD ; i++ ) 
    pthread_join(jobs[i], NULL);
  return;
}
